<?php
class ConfigManager {
	
	private $_editor_conf_file_path;
	private $_conf_items;
	
	public function __construct($default_conf_file = '') {
		$this->_editor_conf_file_path = $default_conf_file;
		$this->_conf_items = array();
		
		$fh = fopen($this->_editor_conf_file_path, 'r') or die('Cannot open file: ' . $this->_editor_conf_file_path . '!');
		while(!feof($fh)) {
			$oline = fgets($fh);
			$pline = str_replace(array("\r", "\n", "\r\n"), '', ltrim($oline));
			if((strlen($pline) == 0) || (substr($pline, 0, 1) == '#')) {
				continue;
			}
			$arr_opt = preg_split('/\t|\s{2,}/', $pline);
			$opt = array(
				'name' => $arr_opt[0],
				'value' => $arr_opt[1]
			);
			array_push($this->_conf_items, $opt);
		}
		fclose($fh);
	}
	
	public function get_confs() {
		return json_encode($this->_conf_items);
	}
	
	public function get_conf_item($conf_name) {
		foreach($this->_conf_items as $c) {
			if($c['name'] == $conf_name) {
				return $c['value'];
			}
		}
		return '';
	}
	
}
?>