<?php
require_once('config.php');
require_once('../auth.php');
require_once('classes/FileManager.php');

function startsWith($haystack, $needle, $case=TRUE) {
	if($case) { return (strcmp(substr($haystack, 0, strlen($needle)), $needle) === 0); }
	return (strcasecmp(substr($haystack, 0, strlen($needle)), $needle) === 0);
}

function endsWith($haystack, $needle, $case=TRUE) {
    if($case) { return (strcmp(substr($haystack, strlen($haystack) - strlen($needle)), $needle) === 0); }
    return (strcasecmp(substr($haystack, strlen($haystack) - strlen($needle)), $needle) === 0);
}

function rrmdir($dir) {
	if(is_dir($dir)) {
		$objects = scandir($dir);
		foreach($objects as $object) {
			if($object != "." && $object != "..") {
				if(filetype($dir . "/" . $object) == "dir")
					rrmdir($dir . "/" . $object);
				else
					unlink($dir. "/" . $object);
			}
		}
		reset($objects);
		rmdir($dir);
	}
}

$fm = new FileManager();

$service_type = $_REQUEST['service'];

switch($service_type) {
case 'load_folder_tree':
	$user_perm_path = $_REQUEST['user_permission_folder'];
	if($user_perm_path == '/index.shtml') {
		echo(json_encode($fm->loadFolderTree($ne2_config_info['upload_dir'])));
	} else {
		$root_path = $_SERVER['DOCUMENT_ROOT'] . $user_perm_path;
		$root_path = str_replace('/index.shtml', '', $root_path);
		echo(json_encode($fm->loadFolderTree($root_path, FALSE)));
	}
	break;
case 'get_file_list':
	$current_path = $_REQUEST['current_path'];
	echo(json_encode($fm->getFileList($current_path)));
	break;
case 'get_file_info':
	$file_path = $_REQUEST['file_path'];
	echo(json_encode($fm->getFileInfo($file_path)));
	break;
case 'create_subfolder':
	$current_path = $_REQUEST['current_path'];
	$new_subfolder_name = $_REQUEST['new_subfolder_name'];
	$succ = $fm->createSubFolder($current_path, $new_subfolder_name);
	if($succ === FALSE) {
		echo('0');
	} else {
		echo('1');
	}
	break;
case 'delete_file':
	$fpath = $_REQUEST['file_path'];
	$fm->deleteFile($fpath); // TODO delete thumb too!!!
	break;
case 'load_file_content':
	$fpath = $_REQUEST['file_path'];
	$fpath = $_SERVER['DOCUMENT_ROOT'] . $fpath;
	echo($fm->getFileContent($fpath));
	break;
case 'save_file_content':
	$fpath = $_SERVER['DOCUMENT_ROOT'] . $_REQUEST['file_path'];
	$content = $_REQUEST['new_content'];
	$fm->setFileContent($fpath, $content);
	echo("File updated!");
	break;
case 'check_dup_name':
	$file_path = $_REQUEST['file_path'];
	if(file_exists($file_path)) {
		echo('1');
	} else {
		echo('0');
	}
	break;
case 'delete_folder':
	$folder = $_POST['folder'];
	$un_folders = array('vkdaten', 'ssi', 'css', 'grafiken', 'img', 'js');
	if(is_dir($folder)) {
		if(endsWith($folder, 'websource') || endsWith($folder, 'websource/')) { // root dir!
			echo('Dieses Verzeichnis darf nicht entfernt werden!');
			return;
		}
		foreach($un_folders as $uf) {
			if(endsWith($folder, $uf) || endsWith($folder, $uf . '/')) {
				echo('Dieses Verzeichnis darf nicht entfernt werden!');
				return;
			}
		}
	}
	rrmdir($folder);
	echo('Done!');
	break;
default:
	break;
}
?>