<?php
require_once('../auth.php');

function result($inst, $street, $plz, $city, $person, $personvorname, $telefon, $fax, $email, $lat, $lon) {
	$contactdata = "name\t" . $inst . "\nstrasse\t" . $street . "\nort\t" . $city . "\nplz\t" . $plz . "\nemail\t" . $email . "\ntelefon\t" . $telefon . "\nfax\t" . $fax . "\ngeo-lat\t" . $lat . "\ngeo-long\t" . $lon . "\nkontakt1-name\t" . $person . "\nkontakt1-vorname\t" . personvorname . "\n";
	// Generierung der Tilemap für abgeschaltetes javascript
	$n = pow(2, 16);
	$xtile = floor((($lon + 180) / 360) * $n);
	$ytile = floor((1 - log(tan($lat * pi()/180) + 1 / cos($lat * pi()/180)) / pi()) /2 * $n);
	
	$shtml = "
	<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"
		\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">
	<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"de\" lang=\"de\">
		<head>
		<title>Kontakt</title>
		<!--#include virtual=\"/ssi/head.shtml\" -->
		
		<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />
		<meta http-equiv=\"content-script-type\" content=\"text/javascript\" />
		<meta http-equiv=\"content-style-type\" content=\"text/css\" />
		<meta http-equiv=\"content-language\" content=\"de\" />
	
	<link rel=\"stylesheet\" type=\"text/css\" href=\"http://www.vorlagen.uni-erlangen.de/css/osm-karte.css\">
	<script type=\"text/javascript\" src=\"http://www.openlayers.org/api/OpenLayers.js\"></script>
	<script type=\"text/javascript\" src=\"http://www.openstreetmap.org/openlayers/OpenStreetMap.js\"></script>
	<script type=\"text/javascript\" src=\"http://www.vorlagen.uni-erlangen.de/js/osm-karte.js\"></script>
	<script type=\"text/javascript\" src=\"http://www.vorlagen.uni-erlangen.de/js/osm-karte-funktionen.js\"></script>
	<script type=\"text/javascript\">
	var map;
	var layer_mapnik;
	var layer_tah;
	var layer_markers;
	
	function drawmap() {
		OpenLayers.Lang.setCode('de');
		
		// Position und Zoomstufe der Karte
		var lon = " . $lon . ";
		var lat = " . $lat . ";
		var zoom = 16;
		
		map = new OpenLayers.Map('map', {
			projection: new OpenLayers.Projection(\"EPSG:900913\"),
			displayProjection: new OpenLayers.Projection(\"EPSG:4326\"),
			controls: [
				new OpenLayers.Control.MouseDefaults(),
				new OpenLayers.Control.PanZoomBar()
			],
			maxExtent: new OpenLayers.Bounds(-20037508.34, -20037508.34, 20037508.34, 20037508.34),
			numZoomLevels: 18,
			maxResolution: 156543,
			units: 'meters'
		});
		layer_mapnik = new OpenLayers.Layer.OSM.Mapnik(\"Mapnik\");
		layer_markers = new OpenLayers.Layer.Markers(\"Address\", {
			projection: new OpenLayers.Projection(\"EPSG:4326\"), 
			visibility: true,
			displayInLayerSwitcher: false
		});
		map.addLayers([layer_mapnik, layer_markers]);
		jumpTo(lon, lat, zoom);
		
		// Position des Markers
		addMarker(layer_markers, " . $lon . ", " . $lat . ", \"<span class=\\\"popuptitle\\\">" . $inst . "</span><br /><span class=\\\"popuptext\\\">" . $desc . "</span>\");\n\t\t
		document.getElementById(\"noscript\").style.visibility = \"hidden\";
	}
	</script>
	</head>
	<body onload=\"drawmap();\">
		<div id=\"seite\">
			<a name=\"seitenmarke\" id=\"seitenmarke\"></a>
	<!-- KOPF ******************************************************************** -->
	<!-- ************************************************************************** -->
	<div id=\"kopf\">
		<div id=\"logo\"></div>
		<div id=\"titel\">
			<h1>Kontakt</h1>	
		</div>
		<!--#include virtual=\"/ssi/kopf.shtml\" -->
	</div>
	<hr id=\"nachkopf\" />
	<!-- MENU ********************************************************************* -->
	<!-- ************************************************************************** -->
	<div id=\"main\">
		<div id=\"menu\">
			<div id=\"bereichsmenu\">
				<h2><a name=\"bereichsmenumarke\" id=\"bereichsmenumarke\">Bereichsmenu</a></h2>
			<!--#include virtual=\"/cgi-bin/navigation/navigation.pl\" -->
			</div>
			<!--#include virtual=\"/ssi/kurzinfo.shtml\" -->
		</div>
	<!-- CONTENT ****************************************************************** -->
	<!-- ************************************************************************** -->
		<div id=\"content\">
			<a name=\"contentmarke\" id=\"contentmarke\"></a>
			<!-- Inhaltsinfo ************************************************************** -->
			<!-- ************************************************************************** -->
			<!--#include virtual=\"/ssi/inhaltsinfo.shtml\" -->
			<!-- TEXT AB HIER -->
			<table>
			<div class=\"vcard\">
				<tr class=\"eins\">
					<th class=\"zeile\">Adresse</th>
					<td>
						<span class=\"org\">" . $inst . "</span><br />" . $personvorname . " " . $person . "<br/><span class=\"street-address\">" . $street . "</span><br /><span class=\"postal-code\">" . $plz . "</span> <span class=\"locality\">" . $city . "</span>
					</td>
				</tr>
				<tr class=\"zwei\">
					<th class=\"zeile\">Telefon</th>
					<td><span class=\"tel\">" . $telefon . "</span></td>
				</tr>";
				
				if(!empty($fax)) {
					$shtml = $shtml . "
					<tr class=\"eins\">
						<th class=\"zeile\">Fax</th>
						<td><span class=\"fax\">" . $fax . "</span></td>
					</tr>";
				}
				
				$shtml = $shtml . "
					<tr class=\"eins\">
						<th class=\"zeile\">E-Mail</th>
						<td><span class=\"email\"><a href=\"mailto:" . $email . "\">" . $email . "</a></span></td>
					</tr>
					<tr class=\"zwei\">
						<th class=\"zeile\">GEO-Informationen</th>
						<td>
							<span class=\"geo\">
								<abbr class=\"latitude\" title=\"" . $lat . "\">" . $lat . "</abbr>,
								<abbr class=\"longitude\" title=\"" . $lon . "\">" . $lon . "</abbr>
							</span>
						</td>
					</tr>	
				</div>		 				
			</table>
	<h2>Lage</h2>		  
	<div id=\"map\">
	<div id=\"noscript\" style=\"position:absolute;width:inherit;\">
	<img src=\"http://a.tile.openstreetmap.org/16/" . $xtile . "/" . $ytile . ".png\">
	<p>Aktivieren Sie Javascript um die interaktive Umgebungskarte zu nutzen oder rufen Sie die <a href=\"http://server.tah.openstreetmap.org/Browse/?layer=tile&z=16&x=" . $xtile . "&y=" . $ytile . "\">scriptfreie Umgebungskarte</a> auf.</p>
	</div>
	</div>	
	<div style=\"position:relative;bottom:0px;display:block;font-family:Arial;font-size:smaller;right:3px;\">Karte von <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a></div>		
	<!-- AB HIER KEIN TEXT MEHR -->
		<hr id=\"vorfooter\" />
	</div><!-- /content -->
	<!-- FOOTER ******************************************************************* -->
	<!-- ************************************************************************** -->
		</div><!-- /main -->
		<div id=\"footer\">
			<h2><a name=\"footermarke\" id=\"footermarke\">Statusinformationen zur Seite</a></h2>
			<p>
			Letzte &Auml;nderung:
			<!--#config timefmt=\"%d.%m.%Y um %H:%M Uhr\"--><!--#echo var=\"LAST_MODIFIED\"-->
			</p>
			<div id=\"footerinfos\">
				<div id=\"tecmenu\">
				<h2 class=\"u\"><a name=\"hilfemarke\" id=\"hilfemarke\">Technisches Menu</a></h2>
				<!--#include virtual=\"/cgi-bin/navigation/inhalt.pl?type=sonder&noU=1&nodfn=1&nochilds=1\" -->
				</div>
				<!-- ZUSATZINFO *************************************************************** -->
				<!-- ************************************************************************** -->
				<!--#include virtual=\"/ssi/zusatzinfo.shtml\" -->
			</div><!-- /footerinfos -->
			</div>
		</div><!-- /seite -->
	</body>
	</html>";
	
	return $shtml;
}

$shtml = result(entities($_POST["inst"]), entities($_POST["street"]), entities($_POST["plz"]), entities($_POST["city"]), entities($_POST["personname"]), entities($_POST["personvorname"]), entities($_POST["telefon"]), entities($_POST["fax"]), entities($_POST["email"]), entities($_POST["lat"]), entities($_POST["lon"]));

$contactdata = "name\t".$_POST["inst"]."\nstrasse\t".$_POST["street"]."\nplz\t".$_POST["plz"]."\nort\t".$_POST["city"]."\nkontakt1-name\t".$_POST["personname"]."\nkontakt1-vorname\t".$_POST["personvorname"]."\ntelefon\t".$_POST["telefon"]."\nfax\t".$_POST["fax"]."\nemail\t".$_POST["email"]."\ngeo-lat\t".$_POST["lat"]."\ngeo-long\t".$_POST["lon"];

$dateiname2 = $_SERVER['DOCUMENT_ROOT']."/kontakt.shtml";
$datei2 = fopen($dateiname2, "w");

fwrite($datei2, $shtml);
fclose($datei2);

$dateiname3 = $_SERVER['DOCUMENT_ROOT']."/vkdaten/contactdata.conf";
$datei3 = fopen($dateiname3, "w");

fwrite($datei3, $contactdata);
fclose($datei3);

function entities($string) {
		$string = str_replace("ß", "&szlig;", $string);
		$string = str_replace("ä", "&auml;", $string);
		$string = str_replace("ö", "&ouml;", $string);
		$string = str_replace("ü", "&uuml;", $string);
		$string = str_replace("Ä", "&Auml;", $string);
		$string = str_replace("Ö", "&Ouml;", $string);
		$string = str_replace("Ü", "&Uuml;", $string);
		$string = str_replace("€", "&euro;", $string);
		$string = str_replace("é", "&eacute;", $string);
		$string = str_replace("É", "&Eacute;", $string);
		$string = str_replace("è", "&egrave;", $string);
		$string = str_replace("È", "&Egrave;", $string);
		$string = str_replace("á", "&aacute;", $string);
		$string = str_replace("Á", "&Aacute;", $string);
		$string = htmlentities($string);
		return $string;
}
?>