<?php
require_once('auth.php');
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Logo bearbeiten - RRZE NavEditor 2.0 Beta</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />

<script type="text/javascript" src="js/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript">
var imgObj, imgW, imgH;

function loadContentCallback(data) {
	$("#txtUsingText").val(data.content_text);
	$("#txtDesc").val(data.content_desc);
	$("#txtUsingImage").val(data.content_img);
	$("#txtImageAlt").val(data.content_img_alt);
	$("#txtUsingText1").val(data.site_title_text);
	if(data.content_img != "") {
		imgObj = new Image();
		imgObj.src = data.content_img;
		imgObj.onload = previewImageLoadCallback;
		var imgStr = "<img alt=\"\" src=\"" + data.content_img + "\" />";
		$("#imgPrev").html(imgStr);
	}
}

function saveContentCallback(data) {
	$("#ajaxLoader").hide();
	alert(data);
//	location.reload();
}

$(document).ready(function() {
	$("#btnUpdate").click(function() {
		var text = $("#txtUsingText").val();
		var desc = $("#txtDesc").val();
		var img = $("#txtUsingImage").val();
		var imgAlt = $("#txtImageAlt").val();
		var siteTitle = $("#txtUsingText1").val();
		
		// if image specified, then alt-text cannot be empty!
		if(img != "") {
			if(imgAlt == "") {
				alert("Bitte geben Sie die Beschreibung zu Ihrem Logobild an!");
				return false;
			}
		}
		
		if(confirm("Are you sure to save?")) {
			if(img != "") {
				img = "<img alt=\"" + imgAlt + "\" src=\"" + $("#txtUsingImage").val() + "\" width=\"" + imgW + "\" height=\"" + imgH + "\" border=\"0\" />";
			}
			var templname = $("#selTempl").val();
			var pdata = {
				"content_text": text,
				"content_desc": desc,
				"content_img": img,
				"content_img_alt": imgAlt,
				"site_title_text": siteTitle,
				"content_allow_html": $("#chkAllowHtml:checked").length > 0 ? true : false
			};
			$.post("app/edit_logo.php", {
				"json_oper": "update_content",
				"json_content": JSON.stringify(pdata),
				"template_name": templname
			}, saveContentCallback);
		}
	});
	
	$("#btnLoadLogo").click(function() {
		$.getJSON("app/edit_logo.php?r=" + Math.random(), {
			"json_oper": "get_content",
			"template_name": $("#selTempl").val()
		}, loadContentCallback);
	});
	
	$("#txtUsingImage").change(function() {
		var imgsrc = $(this).val();
		imgObj = new Image();
		imgObj.src = imgsrc;
		imgObj.onload = previewImageLoadCallback;
		var imgStr = "<img alt=\"\" src=\"" + imgsrc + "\" />";
		$("#imgPrev").html(imgStr);
	});
	
	$("#btnUpdateExisted").click(function() {
		if(confirm("Are you sure to replace the Logos of all the existing pages?")) {
			$("#ajaxLoader").show();
			var text = $("#txtUsingText").val();
			var desc = $("#txtDesc").val();
			var img = $("#txtUsingImage").val();
			var imgAlt = $("#txtImageAlt").val();
			var siteTitle = $("#txtUsingText1").val();
			if(img != "") {
				img = "<img alt=\"" + imgAlt + "\" src=\"" + $("#txtUsingImage").val() + "\" width=\"" + imgW + "\" height=\"" + imgH + "\" border=\"0\" />";
			}
			var templname = $("#selTempl").val();
			var pdata = {
				"content_text": text,
				"content_desc": desc,
				"content_img": img,
				"content_img_alt": imgAlt,
				"site_title_text": siteTitle,
				"content_allow_html": $("#chkAllowHtml:checked").length > 0 ? true : false
			};
			$.post("app/edit_logo.php", {
				"json_oper": "update_content_all",
				"json_content": JSON.stringify(pdata),
				"template_name": templname
			}, saveContentCallback);
		}
	});
	
	$("#btnCopySiteName").click(function() {
		$("#txtUsingText1").val($("#txtUsingText").val());
	});
	
	// initial load
	$.getJSON("app/edit_logo.php?r=" + Math.random(), {
		"json_oper": "get_content",
		"template_name": $("#selTempl").val()
	}, loadContentCallback);
	
});

function previewImageLoadCallback() {
	if(imgObj.complete) {
		imgW = imgObj.width;
		imgH = imgObj.height;
	}
}
</script>
</head>

<body id="bd_Logo">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 <sup>beta</sup></h1>
	<div id="navBar">
		<?php require('common_nav_menu.php'); ?>
	</div>
	
	<div id="contentPanel1">
		<form action="" method="post" name="frmEdit" id="frmEdit">
			<fieldset>
				<legend>Logo bearbeiten</legend>
				<p>
					<label>Seitenvorlage:</label><br />
					<select id="selTempl" name="selTempl">
						<option selected="selected" value="seitenvorlage.html">Standard</option>
						<option value="news.shtml">News</option>
						<option value="mitarbeiterliste.shtml">Mitarbeiter</option>
						<option value="organigramm.shtml">Organigramm</option>
					</select>
					<input type="button" id="btnLoadLogo" name="btnLoadLogo" value="Load" class="button" />
				</p>
				<p>
					<label for="txtUsingText">Name des Webauftritts:</label><br />
					<input type="text" id="txtUsingText" name="txtUsingText" class="textBox" size="40" />
					<input type="checkbox" id="chkAllowHtml" name="chkAllowHtml" value="ja" />
					<label for="chkAllowHtml">Eigene HTML-Anweisungen zulassen</label>
				</p>
				<p>
					<label for="txtUsingText1">Titel des Webauftritts (auf dem Browser-Titelbar gezeigt wird):</label><br />
					<input type="text" id="txtUsingText1" name="txtUsingText1" class="textBox" size="40" />
					<input type="button" id="btnCopySiteName" class="button" value="aus Name kopieren" />
				</p>
				<p>
					<label for="txtDesc">Kurzbeschreibung zum Webauftritt:</label><br />
					<input type="text" id="txtDesc" class="textBox" size="60" />
				</p>
				<p>
					<label>Bild f&uuml;r das Logo (Optional):</label><br />
					<input type="text" id="txtUsingImage" name="txtUsingImage" class="textBox" size="40" />
					<a href="file_editor.php" target="_blank">Bild hochladen...</a>
					<br />
					<div id="imgPrev"></div>
					<label>Alternativer Text f&uuml;r das Bildlogo (falls die Grafik nicht angezeigt oder angesehen werden kann):</label><br />
					<input type="text" id="txtImageAlt" name="txtImageAlt" class="textBox" size="40" />
				</p>
				<hr size="1" noshade="noshade" />
				<input type="button" id="btnUpdate" name="btnUpdate" value="Update Template" class="button" />
				<input type="button" id="btnUpdateExisted" name="btnUpdateExisted" value="Update Existed Pages" class="button" />
				<img id="ajaxLoader" alt="please wait..." src="ajax-loader.gif" border="0" width="16" height="16" style="display:none;" />
			</fieldset>
		</form>
	</div>
	
<?php require('common_footer.php'); ?>	
</div>
</body>

</html>
