<?php
require_once('auth.php');
if(!$is_admin) { // this page is for admin only!
	auth401();
}
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Live Update - RRZE NavEditor 2.0 Beta</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />

<script type="text/javascript" src="js/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="js/json2.js"></script>

<script type="text/javascript">
	var sv = "";
	var tv = "";
	var goback = false;
	
	function check() {
		$("#imgLoading").show();
		$.post("app/live_update.php", {
			"oper": "check_update"
		}, function(rdata) {
			var jdata = JSON.parse(rdata);
			$("#imgLoading").hide();
			if(jdata.error != "") {
				$("#errorMsg").html(jdata.error);
			} else {
				$("#cur_ver").html(jdata.current_version);
				if(jdata.has_stable_update == false) {
					$("#stb_ver").html(jdata.stable_version);
					sv = jdata.stable_version;
					$("#btnDoUpdate").removeAttr("disabled");
					goback = true;
				} else {
					$("#stb_ver").html("<span style='color:red;'>" + jdata.stable_version + "<br />Neue stabile Version verf&uuml;gbar, klicken Sie auf Update!</span><br />" + jdata.stable_chlog);
					sv = jdata.stable_version;
					$("#btnDoUpdate").removeAttr("disabled");
				}
				
				if(jdata.has_test_update == true) {
					$("#tst_ver").html(jdata.test_version + "<br />" + jdata.test_chlog);
					tv = jdata.test_version;
					$("#btnDoTestUpdate").removeAttr("disabled");
				}
			}
		});
	}

	$(document).ready(function() {
		$("#btnDoUpdate").click(function() {
			if(goback) {
				if(!confirm("Sind Sie sicher, auf eine alte stabile Version zu verschieben?")) {
					return;
				}
			}
			$("#imgLoading").show();
			$("#btnDoUpdate").attr("disabled", "true");
			$.post("app/live_update.php", {
				"oper": "do_update",
				"uv": sv
			}, function(rdata) {
				$("#imgLoading").hide();
				alert(rdata);
				location.reload();
			});
		});
		
		$("#btnDoTestUpdate").click(function() {
			if(!confirm("Sind Sie sicher, auf eine Test-Version zu update?")) {
				return;
			}
			$("#imgLoading").show();
			$("#btnDoTestUpdate").attr("disabled", "true");
			$.post("app/live_update.php", {
				"oper": "do_update",
				"uv": tv
			}, function(rdata) {
				$("#imgLoading").hide();
				alert(rdata);
				location.reload();
			});
		});
		
		$("#btnCheckUpdate").click(function() {
			check();
		});
	});
</script>

</head>

<body id="bd_Update" onload="check();">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 <sup>beta</sup></h1>
	<div id="navBar">
		<?php require('common_nav_menu.php'); ?>
	</div>
	
	<div id="contentPanel1">
		<div id="updateInfo">
			<h3>Aktuelle Version</h3>
			<div id="cur_ver"></div>
			<br />
			<h3>Test-Version</h3>
			<div id="tst_ver"></div>
			<input type="button" id="btnDoTestUpdate" class="button" value="Update" disabled="true" />
			<br />
			<br />
			<h3>Stabile Version</h3>
			<div id="stb_ver"></div>
			<input type="button" id="btnDoUpdate" class="button" value="Update" disabled="true" />
		</div>
		<hr />
		<input type="button" id="btnCheckUpdate" class="button" value="Check" />
		<img id="imgLoading" src="ajax-loader.gif" border="0" width="16" height="16" style="display:none;" />
		<div id="errorMsg" style="color:red;"></div>
	</div>
	
<?php require('common_footer.php'); ?>	
</div>
</body>

</html>